package com.anren.deeplink;

import android.content.Intent;
import android.net.Uri;
import android.provider.Settings;
import android.widget.Toast;

import com.facebook.react.bridge.ReactApplicationContext;

import java.lang.reflect.Array;
import java.util.ArrayList;

/**
 * Created by lcg on 2018/4/11.
 */

public class DeepLink {
    private ReactApplicationContext mReactContext = null;
    private ArrayList<Uri> mDeepLinks = new ArrayList<>();

    private static class SingletonHandler {
        public static DeepLink instance = new DeepLink();
    }

    private DeepLink() {}

    public static DeepLink getInstance() {
        return SingletonHandler.instance;
    }

    public void setApplicationContext(ReactApplicationContext reactContext) {
        mReactContext = reactContext;
    }

    public void handleIntent(Intent intent) {
        Uri uri = intent.getData();

        if (uri == null) {
            return ;
        }

        mDeepLinks.add(uri);

        if (mReactContext == null) {
            return ;
        }

        DeepLinkModule deepLinkModule = mReactContext.getNativeModule(DeepLinkModule.class);
        deepLinkModule.handleUrl(uri);
    }

    public ArrayList<Uri> getDeepLinks() {
        return mDeepLinks;
    }

    public void clearDeepLinks() {
        mDeepLinks.clear();
    }
}
