/**
 * Created by lcg on 2018/4/11.
 */

import { NativeModules, NativeEventEmitter, Platform } from 'react-native';

const DeepLinkEventEmitter = new  NativeEventEmitter(NativeModules.RNDeepLink);

const listeners = {};

export default {
    addListener: function(listener) {
        if (Platform.OS === 'android') {
            if (Object.keys(listeners).length === 0) {
                NativeModules.RNDeepLink.startObserving();
            }
            listeners[listener] = true;
        }

        DeepLinkEventEmitter.addListener(NativeModules.RNDeepLink.EVENT_HANDLE_URL, listener);
    },
    removeListener: function(listener) {
        DeepLinkEventEmitter.removeListener(NativeModules.RNDeepLink.EVENT_HANDLE_URL, listener);

        if (Platform.OS === 'android') {
            if (Object.keys(listeners).length === 1 && listeners[listener]) {
                NativeModules.RNDeepLink.stopObserving();
            }

            delete listeners[listener];
        }
    },
};